Summary: Sendmail X is a message transfer system
Name: smX
Version: 0.1.Beta1.0
Epoch:	 1
Release: 1mdk
URL: http://www.sendmail.org/sm-X/index.html
Source0: ftp://ftp.sendmail.org/pub/sendmail/%{name}-%{version}.tar.bz2
Source1: smX.init
License: Sendmail Open Source License
Group: System/Servers
BuildRoot: %{_tmppath}/%{name}-buildroot
Conflicts: postfix sendmail
BuildRequires: openssl-devel db4-devel libsasl-devel 
%if "%{_lib}" != "lib"
BuildConflicts: lib64db4.3
%else
BuildConflicts: libdb4.3
%endif
Requires(pre): chkconfig rpm-helper
Requires(post): chkconfig rpm-helper net-tools

%description
Sendmail X is a message transfer system that has been designed with 
these main topics in minds:

    * security
    * reliability
    * efficiency
    * configurability
    * extendibility 

Sendmail X consists of five main modules of which only one runs as root:

    * mcp: the main control program is similar to inetd(8)
    * smtps: the SMTP server receives e-mails.
    * smtpc: the SMTP client sends e-mails.
    * smar: the address resolver provides lookups in various maps 
    * qmgr: the queue manager controls the flow of e-mails 

All of these modules run persistently. smtps and smtpc make use of the 
statethreads library which provides a threading API well suited for 
Internet applications, smar and qmgr use the POSIX threads API. 

Sendmail X lacks a local delivery agent. You can install procmail, configured
for lmtp to fulfill this role if desired.

For outgoing mail, mini_sendmail can provide a mail submission program.

%package devel
Group:          Development/Other
Summary:        Development headers for Sendmail X

%description devel
Development headers for Sendmail X

%prep
%setup -q
# (sb) don't hardcode hostname and nameserver from build machine
sed -i 's|^HOSTNAME=|HOSTNAME=""\n#HOSTNAME=|g' misc/sm.setup.sh.in
sed -i 's|^NS=`grep|NS=""\n#NS=`grep|g' misc/sm.setup.sh.in
sed -i 's|res_query (|__res_query (|g' configure

%build
export SMXLOGDIR=%_var/log/smx

%configure \
	--enable-TLS \
	--enable-SASL \
	--with-sasl-incdir=%_includedir \
	--with-sasl-libdir=%_libdir \
	--disable-included-bdb \
	--enable-pmilter

# (sb) parallel make fails
make

# (sb) run the test suite
# seems flakey - goes into endless loop sometimes
export SM_NO_DNS_TEST=1
#make check 

%install
rm -rf $RPM_BUILD_ROOT

# (sb) logs in /var/log
export SMXLOGDIR=%_var/log/smx
install -d $RPM_BUILD_ROOT%_logdir/smx

# (sb) work around crazy "runas" binary
cat > runas <<EOF
#!/bin/sh
if [ "\$1" = "smxm" ];then
  shift
fi
if [ "\$1" = "smxq" ];then
  shift
fi
\$@
EOF

chmod +x runas
export SMXRUNAS=./runas
export SMXCHOWN=/bin/true
export SMXC=`whoami`

%makeinstall_std

MYGID=`id -g`
sed -i "s|$MYGID|SMXC_GID|g" $RPM_BUILD_ROOT/%_sysconfdir/smx/smx.conf
sed -i "s|$RPM_BUILD_ROOT||g"  $RPM_BUILD_ROOT/%_sysconfdir/smx/smx.conf
sed -i "s|$SMXC|smxc|g" $RPM_BUILD_ROOT/%_sysconfdir/smx/smx.conf

mkdir -p $RPM_BUILD_ROOT/%_sysconfdir/logrotate.d/

for i in smtps smtpc qmgr smar
do
cat > $i.logrotate <<EOF
/var/log/smx/$i.log {
    missingok
    compress
    endscript
}
EOF
done

for i in smtps smtpc qmgr smar
do
install -m644 $i.logrotate $RPM_BUILD_ROOT/%_sysconfdir/logrotate.d
done

install -d $RPM_BUILD_ROOT%{_initrddir}
install -m755 %{SOURCE1} -D $RPM_BUILD_ROOT%{_initrddir}/%{name}

# (sb) conf files end up with build paths
sed -i "s|$RPM_BUILD_ROOT||g"  $RPM_BUILD_ROOT/%_var/spool/smx/mcp.sh

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%_pre_useradd smxs /nonexistant /sbin/nologin
%_pre_useradd smxq /nonexistant /sbin/nologin
%_pre_useradd smxc /nonexistant /sbin/nologin
%_pre_useradd smxm /nonexistant /sbin/nologin
%_pre_useradd smx /nonexistant /sbin/nologin
%_pre_groupadd smxs 
%_pre_groupadd smxq 
%_pre_groupadd smxc smxs
%_pre_groupadd smxm smxs,smxq
%_pre_groupadd smx 

%post
%_post_service %{name}

NS=""
RSLVC=/etc/resolv.conf
if test -s ${RSLVC}
then
  NS=`grep '^nameserver' ${RSLVC} | head -1 | sed -e 's/nameserver[    ]*\([0-9][0-9\.]*\).*$/\1/'`
fi
if [ -n "$NS" ];
then
  sed -i "s|nameserver = 127.0.0.1|nameserver = $NS|" %_sysconfdir/smx/smx.conf
fi

HOSTNAME=""
HOSTNAME=`/bin/hostname`
if [ "X${HOSTNAME}" != "X" ]
then
  sed -i "s|unconfigured.host.name|$HOSTNAME|" %_sysconfdir/smx/mt
fi

GID=""
GID=`id -g smxc`
if [ "X${GID}" != "X" ]
then
  sed -i "s|SMXC_GID|$GID|" %_sysconfdir/smx/smx.conf
fi

%preun
%_preun_service %{name}

%postun
%_postun_userdel smxs
%_postun_userdel smxq
%_postun_userdel smxc
%_postun_userdel smxm
%_postun_userdel smx
%_postun_groupdel smxs
%_postun_groupdel smxq
%_postun_groupdel smxc
%_postun_groupdel smxm
%_postun_groupdel smx

%files
%defattr(-,root,root)
%doc ChangeLog README README.dev LICENSE 
%doc doc/README* doc/*.png doc/overview* doc/fs.bib doc/pmilter.api.tex

%_sbindir/greyprint
%_sbindir/greyrm
%_sbindir/mcp
%_bindir/createmap
%_bindir/runas
%_bindir/smconf
%_bindir/mailq
%_bindir/qmgrctl
%_bindir/log2time
%_bindir/rcvrenvfromlog.sh
%_bindir/mailq.sh
%_bindir/qmgrctl.sh

%_libdir/smtps
%_libdir/smtpc
%_libdir/qmgr
%_libdir/smar

%_mandir/man5/*.5*
%_mandir/man8/*.8*

%dir %_var/spool/smx
%attr(0771, smxs, smxq) %dir %_var/spool/smx/0
%attr(0771, smxs, smxq) %dir %_var/spool/smx/1
%attr(0771, smxs, smxq) %dir %_var/spool/smx/2
%attr(0771, smxs, smxq) %dir %_var/spool/smx/3
%attr(0771, smxs, smxq) %dir %_var/spool/smx/4
%attr(0771, smxs, smxq) %dir %_var/spool/smx/5
%attr(0771, smxs, smxq) %dir %_var/spool/smx/6
%attr(0771, smxs, smxq) %dir %_var/spool/smx/7
%attr(0771, smxs, smxq) %dir %_var/spool/smx/8
%attr(0771, smxs, smxq) %dir %_var/spool/smx/9
%attr(0771, smxs, smxq) %dir %_var/spool/smx/A
%attr(0771, smxs, smxq) %dir %_var/spool/smx/B
%attr(0771, smxs, smxq) %dir %_var/spool/smx/C
%attr(0771, smxs, smxq) %dir %_var/spool/smx/D
%attr(0771, smxs, smxq) %dir %_var/spool/smx/E
%attr(0771, smxs, smxq) %dir %_var/spool/smx/F

%attr(0700, smxq, smxq) %dir %_var/spool/smx/defedb
%attr(02770, smxq, smxs) %dir %_var/spool/smx/qmsmtps
%attr(02770, smxq, smxc) %dir %_var/spool/smx/qmsmtpc
%attr(02770, smxq, smxm) %dir %_var/spool/smx/qmsmar
%attr(0750, smxs, smxs) %dir %_var/spool/smx/smtps
%attr(0700, smxq, smxq) %dir %_var/spool/smx/ibdb
%attr(0700, smxq, smxq) %dir %_var/spool/smx/ibdb/ibdb

%_var/spool/smx/mcp.sh
%_var/spool/smx/lognull.sh
%_var/spool/smx/sm.awk

%dir %_logdir/smx
%_logdir/smx/smtps.log
%_logdir/smx/smtpc.log
%_logdir/smx/qmgr.log
%_logdir/smx/smar.log

%dir %_sysconfdir/smx
%attr(0750, smxm, smxm) %config(noreplace) %_sysconfdir/smx/mt
%attr(0755, smx, smx) %config(noreplace) %_sysconfdir/smx/smx.conf
%config(noreplace) %_sysconfdir/smx/Makefile
%config(noreplace) %_sysconfdir/smx/aliases
%config(noreplace) %_sysconfdir/smx/qmgr_conf
%config(noreplace) %_sysconfdir/logrotate.d/*
%{_initrddir}/%{name}

%files devel
%defattr(-,root,root)
%dir %_includedir/smX
%_includedir/smX/*

%changelog
* Wed Mar 22 2006 Stew Benedict <sbenedict@mandriva.com> 0.1.Beta1.0-1mdk
- 0.1.Beta1.0, add Epoch due to upstream numbering
- fix configure flags, buildrequires; work around x86_64 build issue
- update init script for pinit

* Tue Jan 17 2006 Stew Benedict <sbenedict@mandriva.com> 1.0.PreAlpha1.0-1mdk
- first Mandriva packaging - thx misc for the heads up

